--[[
  Rise and Shine Incoming Heals for CT_RaidAssist
  Requires: CT_RaidAssist
  
  Written by: Tattersail <Rise and Shine> on Twisting Nether (EU)

--]]


IH_VERSION = 25
IH_TIMEOUT = 8
IH_RESTIMEOUT = 20
IH_CHECKHEALS_TIMER = 30

IH_IncomingHeals = { }
IH_OutgoingHeals = { }

IH_OutgoingResses = { }

IH_KnownUsers = { }

IH_Emergency = { } -- cache CTRA Emergency monitor
IH_MTTTs = { } -- cache CTRA MTTTs

IH_Active = true
IH_ShowOutgoing = false

IH_LastSpell = nil

IH_CT_RA_ParseMessage_Old = nil
IH_CT_RA_SpellStartCast_Old = nil
IH_CT_RA_SpellEndCast_Old = nil
IH_CT_RA_AddMessage_Old = nil
IH_CT_RA_UpdateUnitHealth_Old = nil
IH_CT_RA_Emergency_UpdateHealth_Old = nil
IT_CT_RA_UpdateMTTT_Old = nil
IH_CastSpell_Old = nil
IH_CastSpellByName_Old = nil
IH_UseAction_Old = nil


function IH_OnLoad()
  SLASH_IH1 = "/ih"
  SlashCmdList["IH"] = IH_SlashHandler

  SLASH_IHVERSION1 = "/ihversion"
  SLASH_IHVERSION2 = "/ihv"
  SlashCmdList["IHVERSION"] = IH_ShowVersion

  SLASH_IHRESET1 = "/ihreset"
  SLASH_IHRESET2 = "/ihr"
  SlashCmdList["IHRESET"] = IH_Reset

  SLASH_IHUSERS1 = "/ihusers"
  SLASH_IHUSERS2 = "/ihu"
  SlashCmdList["IHUSERS"] = IH_ShowUsers

  SLASH_IHENABLE1 = "/ihenable"
  SLASH_IHENABLE2 = "/ihon"
  SlashCmdList["IHENABLE"] = function() IH_Enable(false) end

  SLASH_IHDISABLE1 = "/ihdisable"
  SLASH_IHDISABLE2 = "/ihoff"
  SlashCmdList["IHDISABLE"] = IH_Disable

  SLASH_IHOUT1 = "/ihout"
  SlashCmdList["IHOUT"] = IH_SwitchOutDisplay

  for i = 1, 40 do
    getglobal("CT_RAMember"..i.."_IH"):SetBackdropColor(0, 0, 0, 1)
    getglobal("CT_RAMember"..i.."_IH"):Hide()
    getglobal("CT_RAMember"..i.."_OH"):SetBackdropColor(0, 0, 0, 1)
    getglobal("CT_RAMember"..i.."_OH"):Hide()
    getglobal("CT_RAMember"..i.."_OHText"):SetTextColor(0, 1, 0)
  end
  
  for i = 1, 5 do
    getglobal("CT_RA_EmergencyFrame"..i.."_IH"):SetBackdropColor(0, 0, 0, 1)
    getglobal("CT_RA_EmergencyFrame"..i.."_IH"):Hide()
  end

  for i = 1, 10 do
    getglobal("CT_RAMTGroupMember"..i.."MTTT_IH"):SetBackdropColor(0, 0, 0, 1)
    getglobal("CT_RAMTGroupMember"..i.."MTTT_IH"):Hide()
  end

  this:RegisterEvent("VARIABLES_LOADED")
  
end

function IH_Enable(init)
  if IH_Active and not init then
    echo("|c0000FF00Rise and Shine Incoming Heals|r already |c0060F060enabled|r")
  else
    IH_Active = true

--    this:RegisterEvent("SPELLCAST_START")
    this:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF")

    if UseAction ~= IH_UseAction_New then
      IH_CT_RA_SpellStartCast_Old = CT_RA_SpellStartCast
      IH_CT_RA_SpellEndCast_Old = CT_RA_SpellEndCast
      IH_CT_RA_ParseMessage_Old = CT_RA_ParseMessage
      IH_CT_RA_AddMessage_Old = CT_RA_AddMessage
      IH_CT_RA_UpdateUnitHealth_Old = CT_RA_UpdateUnitHealth
      IH_CT_RA_Emergency_UpdateHealth_Old = CT_RA_Emergency_UpdateHealth
      IH_CT_RA_UpdateMTTT_Old = CT_RA_UpdateMTTT
      IH_CastSpell_Old = CastSpell
      IH_CastSpellByName_Old = CastSpellByName
      IH_UseAction_Old = UseAction

      CT_RA_SpellStartCast = IH_CT_RA_SpellStartCast_New
      CT_RA_SpellEndCast = IH_CT_RA_SpellEndCast_New
      CT_RA_ParseMessage = IH_CT_RA_ParseMessage_New
      CT_RA_AddMessage = IH_CT_RA_AddMessage_New
      CT_RA_UpdateUnitHealth = IH_CT_RA_UpdateUnitHealth_New
      CT_RA_Emergency_UpdateHealth = IH_CT_RA_Emergency_UpdateHealth_New
      CT_RA_UpdateMTTT = IH_CT_RA_UpdateMTTT_New
      CastSpell = IH_CastSpell_New
      CastSpellByName = IH_CastSpellByName_New
      UseAction = IH_UseAction_New
    end

    scheduleRepeat("IH_CheckHeals", IH_CHECKHEALS_TIMER, IH_CheckHeals)

    if init then
      schedule(2, echo, "|c0000FF00Rise and Shine Incoming Heals|r version "..IH_VERSION.." |c0060F060enabled|r")
    else
      echo("|c0000FF00Rise and Shine Incoming Heals|r |c0060F060enabled|r")
    end

  end
end


function IH_Disable()
  if not IH_Active then
    echo("|c0000FF00Rise and Shine Incoming Heals|r already |c00E02020disabled|r")
  else
    IH_Active = false
    
    for i = 1, 40 do
      getglobal("CT_RAMember"..i.."_IH"):Hide()
      getglobal("CT_RAMember"..i.."_OH"):Hide()
    end
    for i = 1, 5 do
      getglobal("CT_RA_EmergencyFrame"..i.."_IH"):Hide()
    end
    IH_IncomingHeals = { }
    IH_OutgoingHeals = { }

--    this:UnregisterEvent("SPELLCAST_START")
    this:UnregisterEvent("CHAT_MSG_SPELL_SELF_BUFF")

    CT_RA_SpellStartCast = IH_CT_RA_SpellStartCast_Old
    CT_RA_SpellEndCast = IH_CT_RA_SpellEndCast_Old
    CT_RA_ParseMessage = IH_CT_RA_ParseMessage_Old
    CT_RA_AddMessage = IH_CT_RA_AddMessage_Old
    CT_RA_UpdateUnitHealth = IH_CT_RA_UpdateUnitHealth_Old
    CT_RA_Emergency_UpdateHealth = IH_CT_RA_Emergency_UpdateHealth_Old
    CT_RA_UpdateMTTT = IH_CT_RA_UpdateMTTT_Old
    CastSpell = IH_CastSpell_Old
    CastSpellByName = IH_CastSpellByName_Old
    UseAction = IH_UseAction_Old

    unscheduleByName("IH_CheckHeals")

    echo("|c0000FF00Rise and Shine Incoming Heals|r |c00E02020disabled|r")

  end
end


function IH_SlashHandler(msg)
  if msg == "enable" or msg == "e" or msg == "on" then IH_Enable(false)
  elseif msg == "disable" or msg == "d" or msg == "off" then IH_Disable()
  elseif msg == "out" then IH_SwitchOutDisplay()
  elseif msg == "version" or msg == "v" then IH_ShowVersion()
  elseif msg == "reset" or msg == "r" then IH_Reset()
  elseif msg == "users" or msg == "u" then IH_ShowUsers()
  else IH_ShowHelp()
  end
end

function IH_ShowHelp()
  echo("|c0000FF00Rise and Shine Incoming Heals|r commands:")
  echo("|c00FF8800/ihon|r Turns Incoming Heals on")
  echo("|c00FF8800/ihoff|r Turns Incoming Heals off")
  echo("|c00FF8800/ihout|r Turns on/off the display of outgoing heals")
  echo("|c00FF8800/ihr|r Resets all numbers")
  echo("|c00FF8800/ihu|r Shows a list of players using Incoming Heals in your raid")
  echo("|c00FF8800/ihv|r Shows current version")
end

function IH_ShowUsers()
  echo("|c0000FF00Rise and Shine Incoming Heals|r known users:")
  for playername, version in IH_KnownUsers do
    if version <= 7 then version = "<= 7" end
    echo(playername.." using version "..version)
  end
end

function IH_ShowVersion()
  echo("|c0000FF00Rise and Shine Incoming Heals|r version "..IH_VERSION)
end

function IH_SwitchOutDisplay()
  if IH_ShowOutgoing then
    echo("Outgoing heals display turned |c00E02020off|r")
    for i = 1, 40 do
      getglobal("CT_RAMember"..i.."_OH"):Hide()
    end
    IH_ShowOutgoing = false
    
  else
    echo("Outgoing heals display turned |c0060F060on|r")
    IH_ShowOutgoing = true

  end
end



--[[

  Spell detection part.
  Many thanks to the CT_RaidAssist team.

--]]



function IH_CastSpell_New(spellId, spellbookTabNum)
  IH_CastSpell_Old(spellId, spellbookTabNum)
  local oldval = GetCVar("UberTooltips")
  SetCVar("UberTooltips", 1)
  CT_RADST:SetSpell(spellId,spellbookTabNum)
  IH_ParseTooltip()
  SetCVar("UberTooltips", oldval)
end

function IH_CastSpellByName_New(spellName)
  IH_CastSpellByName_Old(spellName)
  
  local _, _, spellname = string.find(spellName, "^([^%(]+) %(");
  local _, _, ranktext = string.find(spellName, "%(([^%(]+)%)");

  local spelldata = IH_SpellData[spellname]
  local rankdata = nil

  if spelldata then

    if ranktext then
      rankdata = spelldata.ranks[ranktext]

      if not rankdata then
        rankdata = { plushealing = 0 }
        spelldata.ranks[ranktext] = rankdata
      end

    else
      local ranktext, rankdata, maxamount = nil, nil, 0
      for rt, rd in spelldata.ranks do
        if rd.amount and rd.amount > maxamount then
          rankdata = rd
          ranktext = rt
          maxamount = rd.amount
        end
      end
    end

    IH_LastSpell = {
      spellname = spellname,
      ranktext = ranktext,
      spelldata = spelldata,
      rankdata = rankdata,
    }
  end
end


function IH_UseAction_New(a1, a2, a3)
  local oldval = GetCVar("UberTooltips")
  SetCVar("UberTooltips", 1)
  CT_RADST:SetAction(a1)
  IH_ParseTooltip()
  SetCVar("UberTooltips", oldval)
  IH_UseAction_Old(a1, a2, a3)
end


function IH_ParseTooltip()
  local spellname = CT_RADSTTextLeft1:GetText()
  local spelldata = IH_SpellData[spellname]
  if not spelldata then
    IH_LastSpell = nil
    return
  end
  local ranktext = CT_RADSTTextLeft2:GetText() -- mana cost, spellbook tooltips don't show rank
  local rankdata = spelldata.ranks[ranktext]
  
  if not rankdata then
    rankdata = { plushealing = 0 }
    spelldata.ranks[ranktext] = rankdata
  end

  if not rankdata.minimum then
    local _, _, minimum, maximum = string.find(CT_RADSTTextLeft4:GetText(), IH_TOOLTIP_REGEXP)
    rankdata.minimum = tonumber(minimum)
    rankdata.maximum = tonumber(maximum)
    rankdata.amount = floor((minimum + maximum) / 2)
  end

  IH_LastSpell = {
    spellname = spellname,
    ranktext = ranktext,
    spelldata = spelldata,
    rankdata = rankdata,
  }
  
end


function IH_CT_RA_SpellStartCast_New(spell)
  if IH_LastSpell and spell[2] then
    local spelldata = IH_LastSpell.spelldata
    local rankdata = IH_LastSpell.rankdata
    IH_LastSpell.target = spell[2]
    local amount = rankdata.amount + rankdata.plushealing
    if
        spelldata.bol and
        CT_RA_Stats[IH_LastSpell.target] and
        CT_RA_Stats[IH_LastSpell.target]["Buffs"] and
        CT_RA_Stats[IH_LastSpell.target]["Buffs"]["Blessing of Light"]
    then
      amount = amount + spelldata.bol
    end
    IH_LastSpell.amount = amount
    CT_RA_AddMessage("IHN "..amount.." "..arg2.." "..IH_LastSpell.target)
  end
  return IH_CT_RA_SpellStartCast_Old(spell)
end

function IH_CT_RA_SpellEndCast_New()
  if (event == "SPELLCAST_INTERRUPTED" or event == "SPELLCAST_FAILED") and IH_LastSpell and IH_LastSpell.target and IH_LastSpell.amount then
    CT_RA_AddMessage("IHS "..IH_LastSpell.amount.." "..IH_LastSpell.target)
  end
  return IH_CT_RA_SpellEndCast_Old()
end


function IH_OnEvent(event)
  if event == "VARIABLES_LOADED" then
    if IH_Active then IH_Enable(true) end
    return
  end

  if not IH_LastSpell then return end

  -- detect +healing
  if event == "CHAT_MSG_SPELL_SELF_BUFF" then
    local _, _, spellname, target, amount = string.find(arg1, IH_PLUSHEALING_REGEXP)
    if target == "you" then target = UnitName("player") end
    if IH_LastSpell.spellname ~= spellname then return end
    
    amount = tonumber(amount)
    
    local rankdata = IH_LastSpell.rankdata
    local spelldata = IH_LastSpell.spelldata
    if
      spelldata.bol and
      CT_RA_Stats[target] and
      CT_RA_Stats[target]["Buffs"] and
      CT_RA_Stats[target]["Buffs"]["Blessing of Light"]
    then
      amount = amount - spelldata.bol
    end

    -- calculate + heal
    if amount > rankdata.maximum then rankdata.plushealing = max(rankdata.plushealing, amount - rankdata.maximum) end
    
    -- calculate - heal
    if amount < rankdata.minimum + rankdata.plushealing then rankdata.plushealing = min(0, amount - rankdata.maximum) end
    
  end

end



--[[

  Parse incoming CT_RaidAssist and IncomingHeals messages.

  RES <player>
  RESNO
  IHN <amount> <casttime> <player>
  IHH <amount> <duration> <player>
  IHS <amount> <player>
  IHV <version>
  
  RES - starts res on <player>
  RESNO - stop ressing
  IHN - normal heal
  IHH - HoT - not implemented yet. impossible atm.
  IHS - stop heal - only used when interrupted. 
  
--]]

function IH_CT_RA_ParseMessage_New(source, msg)
  if not IH_Active then return IH_CT_RA_ParseMessage_Old(source, msg) end

  if string.sub(msg, 1, 4) == "RES " then
    local _, _, target = string.find(msg, "^RES (.+)$");
    
    if not IH_OutgoingResses[source] then IH_OutgoingResses[source] = { } end
    local outres = IH_OutgoingResses[source]
    outres.target = target
    outres.time = GetTime()
    
    local raidid = GetPlayerRaidID(target)
    if raidid then
      getglobal("CT_RAMember"..raidid.."_IH"):Show()
      getglobal("CT_RAMember"..raidid.."_IHText"):SetText("RI")
      getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 0)
    end

  elseif string.sub(msg, 1, 5) == "RESNO" then
    local outres = IH_OutgoingResses[source]
    if outres and outres.target then
      local target = outres.target
      local moreres = false
      outres.target = false
      
      for source, outres in IH_OutgoingResses do
        if outres.target and outres.target == target then moreres = true end
      end

      if not moreres then
        local raidid = GetPlayerRaidID(target)
        if raidid then
          getglobal("CT_RAMember"..raidid.."_IH"):Hide()
        end
      end
    end

  elseif string.sub(msg, 1, 4) == "IHN " then
    if not IH_KnownUsers[source] then IH_KnownUsers[source] = 7 end
    IH_FinishHeal(source)

    local _, _, amount, casttime, target = string.find(msg, "^IHN (%d+) (%d+) ([^%s]+)$")
    if amount and casttime and target then

      if not IH_OutgoingHeals[source] then IH_OutgoingHeals[source] = { } end
      local oh = IH_OutgoingHeals[source]
      oh.target = target
      oh.amount = amount
      oh.time = GetTime()
      
      scheduleByName("IHO_"..source, min(casttime / 1000, IH_TIMEOUT), IH_FinishHeal, source)

      if IH_ShowOutgoing then
        local raidid = GetPlayerRaidID(source)
        if raidid then
          getglobal("CT_RAMember"..raidid.."_OH"):Show()
          getglobal("CT_RAMember"..raidid.."_OHText"):SetText("-> "..target)
        end
      end


      local raidid = GetPlayerRaidID(target)
      if raidid then

        if not IH_IncomingHeals[target] then IH_IncomingHeals[target] = { } end
        local ih = IH_IncomingHeals[target]
        if not ih.amount then ih.amount = 0 end
        ih.amount = ih.amount + amount
        ih.time = GetTime()

        scheduleByName("IHI_"..target, IH_TIMEOUT, IH_TimeoutIncomingHeal, target)

        getglobal("CT_RAMember"..raidid.."_IH"):Show()
        getglobal("CT_RAMember"..raidid.."_IHText"):SetText(string.format("%.1f", ih.amount / 1000))
        if UnitHealth("raid"..raidid) + ih.amount > UnitHealthMax("raid"..raidid) then
          getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(0, 1, 0)
        else
          getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 1)
        end
        
        if CT_RA_Emergency_Units[target] then IH_UpdateEmergency(target) end
        if IH_MTTTs[target] then IH_UpdateMTTT(target) end

      end

    end

    return
    
  elseif string.sub(msg, 1, 4) == "IHV " then
    local _, _, version = string.find(msg, "^IHV (%d+)$")
    IH_KnownUsers[source] = tonumber(version)
    return
  
  elseif string.sub(msg, 1, 4) == "IHS " then
    local _, _, amount, playername = string.find(msg, "^IHS (%d+) ([^%s]+)$")
    IH_FinishHeal(source)
    return

  end

  return IH_CT_RA_ParseMessage_Old(source, msg)
end

function IH_TimeoutIncomingHeal(target)
  local ih = IH_IncomingHeals[target]
  if ih and ih.amount and ih.time + IH_TIMEOUT < GetTime() then
    IH_IncomingHeals[target].amount = false
    local raidid = GetPlayerRaidID(target)
    if raidid then getglobal("CT_RAMember"..raidid.."_IH"):Hide() end
    if CT_RA_Emergency_Units[target] then IH_UpdateEmergency(target) end
    if IH_MTTTs[target] then IH_UpdateMTTT(target) end
  end
end


--[[
  Removes an amount from an incoming heal and updates the text in the CTRA member window
--]]
function IH_FinishHeal(source)
  unscheduleByName("IHO_"..source)
  
  if IH_ShowOutgoing then
    local raidid = GetPlayerRaidID(source)
    if raidid then
      getglobal("CT_RAMember"..raidid.."_OH"):Hide()
    end
  end


  local oh = IH_OutgoingHeals[source]
  if oh and oh.target then
    local target = oh.target
    local ih = IH_IncomingHeals[target]
    local raidid = GetPlayerRaidID(target)
    
    oh.target = false

    if ih and ih.amount then
      ih.amount = ih.amount - oh.amount

      if raidid then
      
        if ih.amount == 0 then
          getglobal("CT_RAMember"..raidid.."_IH"):Hide()
        
        else
          getglobal("CT_RAMember"..raidid.."_IH"):Show()
          getglobal("CT_RAMember"..raidid.."_IHText"):SetText(string.format("%.1f", ih.amount / 1000))

          if UnitHealth("raid"..raidid) + ih.amount > UnitHealthMax("raid"..raidid) then
            getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(0, 1, 0)
          else
            getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 1)
          end

        end
      end
    else
      if raidid then
        getglobal("CT_RAMember"..raidid.."_IH"):Hide()
      end
    end
    
    if CT_RA_Emergency_Units[target] then IH_UpdateEmergency(target) end
    if IH_MTTTs[target] then IH_UpdateMTTT(target) end
  end


end

--[[
  Periodically checks all incoming and outgoing heals.
  Lag and bugs can cause values to become "stuck".
  This check should detect this and remove them.
--]]

function IH_CheckHeals()
  for source, oh in IH_OutgoingHeals do
    if oh.target and oh.time + IH_TIMEOUT < GetTime() then
      IH_FinishHeal(source)
    end
  end
  
  for target, ih in IH_IncomingHeals do
    IH_TimeoutIncomingHeal(target)
  end
  
  for source, outres in IH_OutgoingResses do
    if outres.target and outres.time + IH_RESTIMEOUT < GetTime() then
      local target = outres.target
      local moreres = false
      outres.target = false
      
      for source, outres in IH_OutgoingResses do
        if outres.target and outres.target == target then moreres = true end
      end

      if not moreres and (not IH_IncomingHeals[target] or not IH_IncomingHeals[target].amount) then
        local raidid = GetPlayerRaidID(target)
        if raidid then
          getglobal("CT_RAMember"..raidid.."_IH"):Hide()
        end
      end
    end
  end
  
  for raidid = 1, GetNumRaidMembers() do
    local name = GetRaidRosterInfo(raidid)
    
    if getglobal("CT_RAMember"..raidid.."_IH"):IsVisible() then
      local hide = true
      if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then hide = false end
      if hide then
        for source, outres in IH_OutgoingResses do
          if outres and outres.target == name then hide = false end
        end
      end
      if hide then
        getglobal("CT_RAMember"..raidid.."_IH"):Hide()
      end
    end
    
    if getglobal("CT_RAMember"..raidid.."_OH"):IsVisible() then
      local hide = true
      for source, oh in IH_OutgoingHeals do
        if oh and oh.target and oh.target == name then hide = false end
      end
      if hide then
        getglobal("CT_RAMember"..raidid.."_OH"):Hide()
      end
    end
  end
end


--[[
  Update the color of the IH number
--]]
function IH_CT_RA_UpdateUnitHealth_New(frame)
  local raidid = frame:GetID()
  local name = GetRaidRosterInfo(raidid)
  if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then
    local ih = IH_IncomingHeals[name]
    if UnitHealth("raid"..raidid) + ih.amount > UnitHealthMax("raid"..raidid) then
      getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(0, 1, 0)
    else
      getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 1)
    end
    IH_UpdateEmergency(name)
    IH_UpdateMTTT(name)
  end
  return IH_CT_RA_UpdateUnitHealth_Old(frame)
end


--[[
  Update the IH numbers on CTRA Emergency Monitor
--]]

function IH_CT_RA_Emergency_UpdateHealth_New()
  IH_CT_RA_Emergency_UpdateHealth_Old()
  IH_Emergency = { }

  for i = 1, 5 do
    if getglobal("CT_RA_EmergencyFrame"..i):IsVisible() then
      IH_Emergency[name] = i
      IH_UpdateEmergency(name)
    end
  end
end


function IH_UpdateEmergency(name)
  local framename = "CT_RA_EmergencyFrame"..IH_Emergency[name]
  
  if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then
    local ih = IH_IncomingHeals[name]

    if ih.amount == 0 then
      getglobal(framename.."_IH"):Hide()

    else
      local unitid = getglobal(framename.."ClickFrame").unitid
      getglobal(framename.."_IH"):Show()
      getglobal(framename.."_IHText"):SetText(string.format("%.1f", ih.amount / 1000))

      if UnitHealth(unitid) + ih.amount > UnitHealthMax(unitid) then
        getglobal(framename.."_IHText"):SetTextColor(0, 1, 0)
      else
        getglobal(framename.."_IHText"):SetTextColor(1, 1, 1)
      end

    end        

  else
    getglobal(framename.."_IH"):Hide()

  end
end





--[[    MTTT display    ]]--

function IH_CT_RA_UpdateMTTT_New(raidid, mtid, frame, height, key, val)
  IH_CT_RA_UpdateMTTT_Old(raidid, mtid, frame, height, key, val)
  if frame.name then
    IH_MTTTs[frame.name] = frame
    frame.raidid = raidid
    IH_UpdateMTTT(frame.name)
  end
end

function IH_UpdateMTTT(name)
  local frame = IH_MTTTs[name]
  local framename = frame:GetName()
  local raidid = frame.raidid
  if UnitName(raidid) ~= name then
    IH_MTTTs[name] = nil
    return
  end

  if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then
    local ih = IH_IncomingHeals[name]

    if ih.amount == 0 then
      getglobal(framename.."_IH"):Hide()

    else
      getglobal(framename.."_IH"):Show()
      getglobal(framename.."_IHText"):SetText(string.format("%.1f", ih.amount / 1000))

      if UnitHealth(raidid) + ih.amount > UnitHealthMax(raidid) then
        getglobal(framename.."_IHText"):SetTextColor(0, 1, 0)
      else
        getglobal(framename.."_IHText"):SetTextColor(1, 1, 1)
      end

    end        

  else
    getglobal(framename.."_IH"):Hide()

  end  
end



--[[
  Manual reset of all incoming and outgoing heals.
--]]
function IH_Reset()
  IH_IncomingHeals = { }
  IH_OutgoingHeals = { }
  IH_OutgoingResses = { }

  for i = 1, 40 do
    getglobal("CT_RAMember"..i.."_OH"):Hide()
    getglobal("CT_RAMember"..i.."_IH"):Hide()
  end
  for i = 1, 5 do
    getglobal("CT_RA_EmergencyFrame"..i.."_IH"):Hide()
  end
  for i = 1, 10 do
    getglobal("CT_RAMTGroupMember"..i.."MTTT_IH"):Hide()
  end

end



--[[
  Sends IHV when CT_RaidAssist sends V
--]]
function IH_CT_RA_AddMessage_New(msg)
  if string.sub(msg, 1, 1) == "V" then
    CT_RA_AddMessage("IHV "..IH_VERSION)
  end
  IH_CT_RA_AddMessage_Old(msg)
end




function GetPlayerRaidID(playername)
  for i = 1, GetNumRaidMembers(), 1 do
    local name, rank, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
    if playername == name and rank then
      return i
    end
  end
  return nil
end




--[[
  CTRA uses the following msg types:
  RN   - buff renewal
  SR   - status request
  S    - status report
  MS   - /rs message
  V    - version check
  SET  - MTTT set
  SET2 - MTTT set
  R    - remove MTTT
  DB     - disband raid
  RESSED - player is ressed
  NORESSED - remove ressed
  RES - ressing player X (res monitor)
  RESNO - stop ressing player X (res monitor)
  CHECKREADY - ready check
  READY
  NOTREADY
  CHECKRLY - rly check
  YARLY - ya rly
  NORLY - no rly
  AFK
  UNAFK
  DND
  UNDND
  ASSISTME
  STOPASSIST
  DURC - request duration
  DUR - send duration
  RSTC - request resistance
  RST -  send resistance
  REAC - request reagents
  REA - send reagents
  ITMC - request item check
  ITM - send item
  CD - cooldown check
  

--]]
